% solving Laplacian inverse
function [mx , my]=LI(a, N)
mx=zeros(N-1, N);
my=zeros(N, N-1);
phi=zeros(N^2,1);

A=laplacian(N);
B=A(1:N^2-1, 1:N^2-1);
phi(1:N^2-1)=B^(-1)*a;

f=@(i,j) i+(j-1)*N;


for i=1:N-1
    for j=1:N
        mx(i,j)=phi(f(i+1,j))-phi(f(i,j));
    end
end

for i=1:N
    for j=1:N-1
        my(i,j)=phi(f(i,j+1))-phi(f(i,j));
    end
end