function [A, b]=div(rho0, rho1, x_max, N, T)
dt=1/(T-1); dx=x_max/(N-1);
%% Creat Constraint function
% dp/dt+nabla * m =0 with Ax=b
% x=[p m]
%% b
count=(T-1)*N^2;
b=zeros(count,1);
for i=1:N
    for j=1:N
        b(i+(j-1)*N)=rho0(i,j)/dt;
        b(count+i+(j-1)*N)=rho1(i,j);
    end
end

%% A

A=sparse(N^2*(T-1)+N^2-1,  N^2*(T-1)+2*(N-1)*N*(T-1));

f=@(i,j,k) i+(j-1)*N+(k-2)*N^2; % p total N^2*(T-1)
gx=@(i,j,k) N^2*(T-1)+i+(j-1)*(N-1)+(k-2)*(N-1)*N; % mx total (N-1)*N*(T-1)
gy=@(i,j,k) N^2*(T-1)+(N-1)*N*(T-1)+i+(j-1)*N+(k-2)*(N-1)*N; % my total (N-1)*N*(T-1)

ct=@(i,j,k) i+(j-1)*N+(k-2)*N^2;
%% Time Boudnary
k=2;
for i=2:N-1
    for j=2:N-1
        A(ct(i,j,k), f(i,j,k))=1/dt;
        A(ct(i,j,k), gx(i,j,k))=1/dx;
        A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
        A(ct(i,j,k), gy(i,j,k))=1/dx;
        A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
    end
end

% four boundaries
i=1;
for j=2:N-1
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), gx(i,j,k))=1/dx;
    %A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
    A(ct(i,j,k), gy(i,j,k))=1/dx;
    A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
end

i=N;
for j=2:N-1
    A(ct(i,j,k), f(i,j,k))=1/dt;
    % A(ct(i,j,k), gx(i,j,k))=1/dx;
    A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
    A(ct(i,j,k), gy(i,j,k))=1/dx;
    A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
end

j=1;
for i=2:N-1
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), gx(i,j,k))=1/dx;
    A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
    A(ct(i,j,k), gy(i,j,k))=1/dx;
    %  A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
end

j=N;
for i=2:N-1
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), gx(i,j,k))=1/dx;
    A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
    %  A(ct(i,j,k), gy(i,j,k))=1/dx;
    A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
end

% four corners
i=1; j=1;
A(ct(i,j,k), f(i,j,k))=1/dt;
A(ct(i,j,k), gx(i,j,k))=1/dx;
A(ct(i,j,k), gy(i,j,k))=1/dx;
i=1; j=N;
A(ct(i,j,k), f(i,j,k))=1/dt;
A(ct(i,j,k), gx(i,j,k))=1/dx;
A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
i=N; j=1;
A(ct(i,j,k), f(i,j,k))=1/dt;
A(ct(i,j,k), gx(i-1,j, k))=-1/dx;
A(ct(i,j,k), gy(i,j,k))=1/dx;
i=N; j=N;
A(ct(i,j,k), f(i,j,k))=1/dt;
A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
A(ct(i,j,k), gy(i,j-1,k))=-1/dx;

%% Spatial Boundary

% four boundaries
i=1;
for k=3:T
    for j=2:N-1
        A(ct(i,j,k), f(i,j,k))=1/dt;
        A(ct(i,j,k), f(i,j,k-1))=-1/dt;
        A(ct(i,j,k), gx(i,j,k))=1/dx;
        %A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
        A(ct(i,j,k), gy(i,j,k))=1/dx;
        A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
    end
end

i=N;
for k=3:T
    for j=2:N-1
        A(ct(i,j,k), f(i,j,k))=1/dt;
        A(ct(i,j,k), f(i,j,k-1))=-1/dt;
        % A(ct(i,j,k), gx(i,j,k))=1/dx;
        A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
        A(ct(i,j,k), gy(i,j,k))=1/dx;
        A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
    end
end

j=1;
for k=3:T
    for i=2:N-1
        A(ct(i,j,k), f(i,j,k))=1/dt;
        A(ct(i,j,k), f(i,j,k-1))=-1/dt;
        A(ct(i,j,k), gx(i,j,k))=1/dx;
        A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
        A(ct(i,j,k), gy(i,j,k))=1/dx;
        %A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
    end
end

j=N;
for k=3:T
    for i=2:N-1
        A(ct(i,j,k), f(i,j,k))=1/dt;
        A(ct(i,j,k), f(i,j,k-1))=-1/dt;
        A(ct(i,j,k), gx(i,j,k))=1/dx;
        A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
        %A(ct(i,j,k), gy(i,j,k))=1/dx;
        A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
    end
end

% four corners
i=1; j=1;
for k=3:T
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), f(i,j,k-1))=-1/dt;
    A(ct(i,j,k), gx(i,j,k))=1/dx;
    A(ct(i,j,k), gy(i,j,k))=1/dx;
end

i=1; j=N;
for k=3:T
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), f(i,j,k-1))=-1/dt;
    A(ct(i,j,k), gx(i,j,k))=1/dx;
    A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
end

i=N; j=1;
for k=3:T
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), f(i,j,k-1))=-1/dt;
    A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
    A(ct(i,j,k), gy(i,j,k))=1/dx;
end

i=N; j=N;
for k=3:T
    A(ct(i,j,k), f(i,j,k))=1/dt;
    A(ct(i,j,k), f(i,j,k-1))=-1/dt;
    A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
    A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
end

%% Insider
for k=3:T
    for i=2:N-1
        for j=2:N-1
            A(ct(i,j,k), f(i,j,k))=1/dt;
            A(ct(i,j,k), f(i,j,k-1))=-1/dt;
            A(ct(i,j,k), gx(i,j,k))=1/dx;
            A(ct(i,j,k), gx(i-1,j,k))=-1/dx;
            A(ct(i,j,k), gy(i,j,k))=1/dx;
            A(ct(i,j,k), gy(i,j-1,k))=-1/dx;
        end
    end
end


%% k=T
for i=1:N
    for j=1:N
        A(i+(j-1)*N+(T-1)*N^2, f(i,j,T))=1;
    end
end
%%
b=b(1:size(A,1)-1);
A=A(1:end-1,:);