%% Gradient 
function grad=grad(u, x_max, N, T, beta)
% u=[p m]
% P: k=2...T, i=1...N ;
% m: k=2...T, i=1...N-1;
% f (i, k) for P; g (i, k) for m;
gKrho=zeros(N,N, T);
gKmx=zeros(N-1,N,T);
gKmy=zeros(N,N-1,T);

gIrho=zeros(N,N, T);
[rho, mx, my]=transfer1(u, N, T);
dx=2*x_max/(N-1)^2;

%% Grad K=m^2/P
for k=2:T
    for i=2:N-1
        for j=2:N-1
            gKrho(i,j,k)= -2* (mx(i,j,k))^2/(rho(i,j,k)+ ...
                rho(i+1,j,k))^2-2* (mx(i-1,j,k))^2/(rho(i,j,k)+ ...
                rho(i-1,j,k))^2 -2* (my(i,j,k))^2/(rho(i,j,k)+ ...
                rho(i,j+1,k))^2-2* (my(i,j-1,k))^2/(rho(i,j,k)+ ...
                rho(i,j-1,k))^2;
        end
    end
end
% 4 Boudary

for k=2:T
    i=1;
    for j=2:N-1
        gKrho(i,j,k)= -2* (mx(i,j,k))^2/(rho(i,j,k)+ ...
            rho(i+1,j,k))^2-2* (my(i,j,k))^2/(rho(i,j,k)+ ...
            rho(i,j+1,k))^2-2* (my(i,j-1,k))^2/(rho(i,j,k)+ ...
            rho(i,j-1,k))^2;
    end
end

for k=2:T
    i=N;
    for j=2:N-1
        gKrho(i,j,k)= -2* (mx(i-1,j,k))^2/(rho(i,j,k)+ ...
            rho(i-1,j,k))^2 -2* (my(i,j,k))^2/(rho(i,j,k)+ ...
            rho(i,j+1,k))^2-2* (my(i,j-1,k))^2/(rho(i,j,k)+ rho(i,j-1,k))^2;
    end
end

for k=2:T
    j=1;
    for i=2:N-1
        gKrho(i,j,k)= -2* (mx(i,j,k))^2/(rho(i,j,k)+ rho(i+1,j,k))^2-2* ...
            (mx(i-1,j,k))^2/(rho(i,j,k)+ rho(i-1,j,k))^2 - ...
            2* (my(i,j,k))^2/(rho(i,j,k)+ rho(i,j+1,k))^2;
    end
end

for k=2:T
    j=N;
    for i=2:N-1
        gKrho(i,j,k)= -2* (mx(i,j,k))^2/(rho(i,j,k)+ rho(i+1,j,k))^2- ...
            2* (mx(i-1,j,k))^2/(rho(i,j,k)+ rho(i-1,j,k))^2 - ...
            2* (my(i,j-1,k))^2/(rho(i,j,k)+ rho(i,j-1,k))^2;
    end
end

% 4 Corner

for k=2:T
    i=1; j=1;
    gKrho(i,j,k)= -2* (mx(i,j,k))^2/(rho(i,j,k)+ rho(i+1,j,k))^2 ...
        -2* (my(i,j,k))^2/(rho(i,j,k)+ rho(i,j+1,k))^2;
end

for k=2:T
    i=N;j=1;
    gKrho(i,j,k)= -2* (mx(i-1,j,k))^2/(rho(i,j,k)+ ...
        rho(i-1,j,k))^2 -2* (my(i,j,k))^2/(rho(i,j,k)+ rho(i,j+1,k))^2;
end

for k=2:T
    i=1;j=N;
    gKrho(i,j,k)=-2* (mx(i,j,k))^2/(rho(i,j,k)+ rho(i+1,j,k))^2 - ...
        2* (my(i,j-1,k))^2/(rho(i,j,k)+ rho(i,j-1,k))^2;
end

for k=2:T
    j=N; i=N;
    gKrho(i,j,k)=-2* (mx(i-1,j,k))^2/(rho(i,j,k)+ rho(i-1,j,k))^2 - ...
        2* (my(i,j-1,k))^2/(rho(i,j,k)+ rho(i,j-1,k))^2;
end

% mx, my
for k=2:T
    for i=1:N-1
        for j=1:N
            gKmx(i,j,k)= 4* (mx(i,j,k))/(rho(i,j,k)+ rho(i+1,j,k)) ;
        end
    end
end

for k=2:T
    for i=1:N
        for j=1:N-1
            gKmy(i,j,k)= 4* (my(i,j,k))/(rho(i,j,k)+ rho(i,j+1,k)) ;
        end
    end
end
%% grad I

for k = 2:T
    for i = 1:N
        for j = 1:N
            if i == 1 && j == 1
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i+1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i+1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i+1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j+1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j+1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j+1,k));
            elseif i == 1 && j == N
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i+1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i+1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i+1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j-1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j-1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j-1,k));
            elseif i == N && j == 1
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i-1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i-1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i-1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j+1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j+1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j+1,k));
            elseif i == N && j == N
                gIrho(i,j,k) = log(rho(i-1,j,k)/rho(i-1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i-1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i-1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j-1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j-1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j-1,k));
            elseif i == 1
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i+1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i+1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i+1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j+1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j+1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j+1,k)) + ...
                    log(rho(i,j,k)/rho(i,j-1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j-1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j-1,k));
            elseif i == N
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i-1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i-1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i-1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j+1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j+1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j+1,k)) + ...
                    log(rho(i,j,k)/rho(i,j-1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j-1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j-1,k));
            elseif j == 1
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i+1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i+1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i+1,j,k)) + ...
                    log(rho(i,j,k)/rho(i-1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i-1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i-1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j+1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j+1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j+1,k));
            elseif j == N
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i+1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i+1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i+1,j,k)) + ...
                    log(rho(i,j,k)/rho(i-1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i-1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i-1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j-1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j-1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j-1,k));
            else
                gIrho(i,j,k) = log(rho(i,j,k)/rho(i+1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i+1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i+1,j,k)) + ...
                    log(rho(i,j,k)/rho(i-1,j,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i-1,j,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i-1,j,k)) + ...
                    log(rho(i,j,k)/rho(i,j+1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j+1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j+1,k)) + ...
                    log(rho(i,j,k)/rho(i,j-1,k))^2/2 + ...
                    log(rho(i,j,k)/rho(i,j-1,k))/rho(i,j,k)* ...
                    (rho(i,j,k)+rho(i,j-1,k));
            end
        end
    end
end

%%
grad=real(transfer(gKrho+ beta*gIrho/dx^2,gKmx, gKmy)/(T-1));