function H = hessian(u,x_max, N, T, beta)
HK = sparse(N^2*(T-1)+ 2*(N-1)*N*(T-1),N^2*(T-1)+ 2*(N-1)*N*(T-1));
HI = HK;

f=@(i,j,k) i+(j-1)*N+(k-2)*N^2; % p total N^2*(T-1)
gx=@(i,j,k) N^2*(T-1)+i+(j-1)*(N-1)+(k-2)*(N-1)*N; % mx total (N-1)*N*(T-1)
gy=@(i,j,k) N^2*(T-1)+(N-1)*N*(T-1)+i+(j-1)*N+(k-2)*(N-1)*N; % my total (N-1)*N*(T-1)

[rho, mx, my]=transfer1(u, N, T);
dx=2*x_max/(N-1)^2;
%% HK
for k = 2:T
    for i = 1:N
        for j = 1:N
            fijk = f(i,j,k); 
            fi1jk = fijk + 1;
            fij1k = f(i,j+1,k);
            %% corners
            if i == 1 && j == 1
                temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
                temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
                HK(fijk,fijk) = temp1 + temp2;
                HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;
                HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;
            elseif i == 1 && j == N
                temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
                temp4 = 4*my(i,j-1,k)^2/(rho(i,j,k)+ rho(i,j-1,k))^3;
                HK(fijk,fijk) = temp1 + temp4;
                HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;              
            elseif i == N && j == 1
                temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
                temp3 = 4*mx(i-1,j,k)^2/(rho(i,j,k)+ rho(i-1,j,k))^3;
                HK(fijk,fijk) = temp2 + temp3;
                HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;
            elseif i == N && j == N     
                temp3 = 4*mx(i-1,j,k)^2/(rho(i,j,k)+ rho(i-1,j,k))^3;
                temp4 = 4*my(i,j-1,k)^2/(rho(i,j,k)+ rho(i,j-1,k))^3;
                HK(fijk,fijk) = temp3 + temp4;
            %% edges
            elseif i == 1 
                temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
                temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
                temp4 = 4*my(i,j-1,k)^2/(rho(i,j,k)+ rho(i,j-1,k))^3;
                HK(fijk,fijk) = temp1 + temp2 + temp4;
                HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;
                HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;
            elseif i == N                
                temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
                temp3 = 4*mx(i-1,j,k)^2/(rho(i,j,k)+ rho(i-1,j,k))^3;
                temp4 = 4*my(i,j-1,k)^2/(rho(i,j,k)+ rho(i,j-1,k))^3;
                HK(fijk,fijk) = temp2 + temp3 + temp4;
                HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;
            elseif j == 1
                temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
                temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
                temp3 = 4*mx(i-1,j,k)^2/(rho(i,j,k)+ rho(i-1,j,k))^3;
                HK(fijk,fijk) = temp1 + temp2 + temp3;
                HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;
                HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;
            elseif j == N
                temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
                temp3 = 4*mx(i-1,j,k)^2/(rho(i,j,k)+ rho(i-1,j,k))^3;
                temp4 = 4*my(i,j-1,k)^2/(rho(i,j,k)+ rho(i,j-1,k))^3;
                HK(fijk,fijk) = temp1 + temp3 + temp4;
                HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;
            %% inside
            else
                temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
                temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
                temp3 = 4*mx(i-1,j,k)^2/(rho(i,j,k)+ rho(i-1,j,k))^3;
                temp4 = 4*my(i,j-1,k)^2/(rho(i,j,k)+ rho(i,j-1,k))^3;
                HK(fijk,fijk) = temp1 + temp2 + temp3 + temp4;
                HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;
                HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;
            end            
        end
    end
end

% k =2; i = 1; j= 1;
% fijk = f(i,j,k); 
% fi1jk = fijk + 1;
% fij1k = f(i,j+1,k);
% temp1 = 4*mx(i,j,k)^2/(rho(i,j,k)+ rho(i+1,j,k))^3;
% temp2 = 4*my(i,j,k)^2/(rho(i,j,k)+ rho(i,j+1,k))^3;
% HK(fijk,fijk) = temp1 + temp2;
% HK(fi1jk,fijk) = temp1; HK(fijk,fi1jk) = temp1;
% HK(fij1k,fijk) = temp2; HK(fijk,fij1k) = temp2;

for k = 2:T
    for i = 1:N-1
        for j = 1:N
            fijk = f(i,j,k); gxijk = gx(i,j,k);
            fi1jk = fijk + 1;
           
            temp1 = -4*mx(i,j,k)/(rho(i,j,k)+rho(i+1,j,k))^2;
            
            HK(fijk,gxijk) = temp1; HK(gxijk,fijk) = temp1;
        
            HK(fi1jk,gxijk) = temp1; HK(gxijk,fi1jk) = temp1;
           
        end
    end
end

for k = 2:T
    for i = 1:N
        for j = 1:N-1
            fijk = f(i,j,k); gyijk = gy(i,j,k);            
            fij1k = f(i,j+1,k);        
            temp2 = -4*my(i,j,k)/(rho(i,j,k)+rho(i,j+1,k))^2;            
            HK(fijk,gyijk) = temp2; HK(gyijk,fijk) = temp2;         
            HK(fij1k,gyijk) = temp2; HK(gyijk,fij1k) = temp2;
        end
    end
end


for k = 2:T
    for i = 1:N-1
        for j = 1:N
            gxijk = gx(i,j,k);
            HK(gxijk,gxijk) = 4/(rho(i,j,k)+rho(i+1,j,k));          
        end
    end
end

for k = 2:T
    for i = 1:N
        for j = 1:N-1
            gyijk = gy(i,j,k);
            HK(gyijk,gyijk) = 4/(rho(i,j,k)+rho(i,j+1,k));          
        end
    end
end
%% HI

for k = 2:T
    for i = 1:N
        for j = 1:N
            fijk = f(i,j,k); fi1jk = fijk+1; fij1k = fijk+N;
            if i == 1 && j == 1
                temp1 = (1/rho(i,j,k)+1/rho(i+1,j,k) ...
                    + log(rho(i+1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i+1,j,k)))/dx^2;               
                temp3 = (1/rho(i,j,k)+1/rho(i,j+1,k) ...
                    + log(rho(i,j+1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j+1,k)))/dx^2;             
                HI(fijk,fijk) = (rho(i+1,j,k)*temp1 + ...
                    rho(i,j+1,k)*temp3)/rho(i,j,k);
                HI(fi1jk,fijk) = -temp1; HI(fijk,fi1jk) = -temp1;
                HI(fij1k,fijk) = -temp3; HI(fijk,fij1k) = -temp3;
                             
            elseif i == 1 && j == N
                temp1 = (1/rho(i,j,k)+1/rho(i+1,j,k) ...
                    + log(rho(i+1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i+1,j,k)))/dx^2;
              
                temp4 = (1/rho(i,j,k)+1/rho(i,j-1,k) ...
                    + log(rho(i,j-1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j-1,k)))/dx^2;
                HI(fijk,fijk) = (rho(i+1,j,k)*temp1 + ...
                    rho(i,j-1,k)*temp4)/rho(i,j,k);
                HI(fi1jk,fijk) = -temp1; HI(fijk,fi1jk) = -temp1;
              
            elseif i == N && j == 1
                
                temp2 = (1/rho(i,j,k)+1/rho(i-1,j,k) ...
                    + log(rho(i-1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i-1,j,k)))/dx^2;
                temp3 = (1/rho(i,j,k)+1/rho(i,j+1,k) ...
                    + log(rho(i,j+1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j+1,k)))/dx^2;
                
                HI(fijk,fijk) = (rho(i-1,j,k)*temp2 + ...
                    rho(i,j+1,k)*temp3)/rho(i,j,k);              
                HI(fij1k,fijk) = -temp3; HI(fijk,fij1k) = -temp3;
                
            elseif i == N && j == N
                
                temp2 = (1/rho(i,j,k)+1/rho(i-1,j,k) ...
                    + log(rho(i-1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i-1,j,k)))/dx^2;
               
                temp4 = (1/rho(i,j,k)+1/rho(i,j-1,k) ...
                    + log(rho(i,j-1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j-1,k)))/dx^2;
                HI(fijk,fijk) = (rho(i-1,j,k)*temp2 + ...
                    + rho(i,j-1,k)*temp4)/rho(i,j,k);
                
            elseif i == 1
                temp1 = (1/rho(i,j,k)+1/rho(i+1,j,k) ...
                    + log(rho(i+1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i+1,j,k)))/dx^2;
               
                temp3 = (1/rho(i,j,k)+1/rho(i,j+1,k) ...
                    + log(rho(i,j+1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j+1,k)))/dx^2;
                temp4 = (1/rho(i,j,k)+1/rho(i,j-1,k) ...
                    + log(rho(i,j-1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j-1,k)))/dx^2;
                HI(fijk,fijk) = (rho(i+1,j,k)*temp1 + ...
                    rho(i,j+1,k)*temp3 + rho(i,j-1,k)*temp4)/rho(i,j,k);
                HI(fi1jk,fijk) = -temp1; HI(fijk,fi1jk) = -temp1;
                HI(fij1k,fijk) = -temp3; HI(fijk,fij1k) = -temp3;
            elseif i == N
                temp2 = (1/rho(i,j,k)+1/rho(i-1,j,k) ...
                    + log(rho(i-1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i-1,j,k)))/dx^2;
                temp3 = (1/rho(i,j,k)+1/rho(i,j+1,k) ...
                    + log(rho(i,j+1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j+1,k)))/dx^2;
                temp4 = (1/rho(i,j,k)+1/rho(i,j-1,k) ...
                    + log(rho(i,j-1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j-1,k)))/dx^2;
                HI(fijk,fijk) = (rho(i-1,j,k)*temp2 + ...
                    rho(i,j+1,k)*temp3 + rho(i,j-1,k)*temp4)/rho(i,j,k);
               
                HI(fij1k,fijk) = -temp3; HI(fijk,fij1k) = -temp3;
            elseif j == 1
                temp1 = (1/rho(i,j,k)+1/rho(i+1,j,k) ...
                    + log(rho(i+1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i+1,j,k)))/dx^2;
                temp2 = (1/rho(i,j,k)+1/rho(i-1,j,k) ...
                    + log(rho(i-1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i-1,j,k)))/dx^2;
                temp3 = (1/rho(i,j,k)+1/rho(i,j+1,k) ...
                    + log(rho(i,j+1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j+1,k)))/dx^2;
              
                HI(fijk,fijk) = (rho(i+1,j,k)*temp1 + rho(i-1,j,k)*temp2 + ...
                    rho(i,j+1,k)*temp3)/rho(i,j,k);
                HI(fi1jk,fijk) = -temp1; HI(fijk,fi1jk) = -temp1;
                HI(fij1k,fijk) = -temp3; HI(fijk,fij1k) = -temp3;
            elseif j == N
                temp1 = (1/rho(i,j,k)+1/rho(i+1,j,k) ...
                    + log(rho(i+1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i+1,j,k)))/dx^2;
                temp2 = (1/rho(i,j,k)+1/rho(i-1,j,k) ...
                    + log(rho(i-1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i-1,j,k)))/dx^2;
               
                temp4 = (1/rho(i,j,k)+1/rho(i,j-1,k) ...
                    + log(rho(i,j-1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j-1,k)))/dx^2;
                HI(fijk,fijk) = (rho(i+1,j,k)*temp1 + rho(i-1,j,k)*temp2 + ...
                     rho(i,j-1,k)*temp4)/rho(i,j,k);
                HI(fi1jk,fijk) = -temp1; HI(fijk,fi1jk) = -temp1;
          
            else
                temp1 = (1/rho(i,j,k)+1/rho(i+1,j,k) ...
                    + log(rho(i+1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i+1,j,k)))/dx^2;
                temp2 = (1/rho(i,j,k)+1/rho(i-1,j,k) ...
                    + log(rho(i-1,j,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i-1,j,k)))/dx^2;
                temp3 = (1/rho(i,j,k)+1/rho(i,j+1,k) ...
                    + log(rho(i,j+1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j+1,k)))/dx^2;
                temp4 = (1/rho(i,j,k)+1/rho(i,j-1,k) ...
                    + log(rho(i,j-1,k)/rho(i,j,k))* ...
                    (1/rho(i,j,k)-1/rho(i,j-1,k)))/dx^2;
                HI(fijk,fijk) = (rho(i+1,j,k)*temp1 + rho(i-1,j,k)*temp2 + ...
                    rho(i,j+1,k)*temp3 + rho(i,j-1,k)*temp4)/rho(i,j,k);
                HI(fi1jk,fijk) = -temp1; HI(fijk,fi1jk) = -temp1;
                HI(fij1k,fijk) = -temp3; HI(fijk,fij1k) = -temp3;
                
            end
            
        end
    end
end
HI = real(HI);
% e = eig(HI); min(e)
H = (HK + beta*HI)/(T-1);
% e = eig(H); min(e)
end