function [rho, mx ,my]=initial(rho0, rho1, x_max,T)
N=size(rho0,2);
dx=x_max/(N-1);
dt=1/(T-1);
x=@(i) (i-1)*dx; % spatial region [0, x_max]
t=@(l) (l-1)*dt;

rho=zeros(N,N, T);

for i=1:N
    for j=1:N
       for k=1:T
            rho(i,j,k)=(1-t(k))*rho0(i,j)+t(k)*rho1(i,j);
       end
    end
end

mx=zeros(N-1, N, T);
my=zeros(N, N-1, T);

for k=2:T
    b=zeros(N^2,1);
    for i=1:N
        for j=1:N
            b(i+(j-1)*N)=-(rho(i,j,k)-rho(i,j,k-1))/dt;
        end
    end
    a=b(1:N^2-1);
    [mx(:,:,k) , my(:,:,k)]=LI(a, N);
    mx(:,:,k)=mx(:,:,k)*dx;
    my(:,:,k)=my(:,:,k)*dx;
end