%% Projection Gradient method Main function
% clc; clear;
% T=30; x_max=2; N=20; beta=0; 
% dx=x_max/(N-1); dt=1/(T-1);
% x=@(i,j) [(i-1)*dx, (j-1)*dx];
% t=@(l) (l-1)*dt;
% h=1e-3; % Step size
% rho0=zeros(N,N);
% rho1=zeros(N,N);
% 
% for i=1:N
%     for j=1:N
%       rho1(i,j)=exp(-norm(x(i,j)-[1.5, 1.5])^2/(1))+1e-3 ; 
%        rho0(i,j)=exp(-norm(x(i,j)-[0.2, 0.5])^2/(1))+1e-3; 
%     end
% end
% rho0=rho0/sum(sum(rho0));
% rho1=rho1/sum(sum(rho1));

clc; clear; close all
T=40; x_max=2; N=30; h = 1e-3;
dx=x_max/(N-1); dt=1/(T-1);
tol = 1e-5; beta = 0;

rho0 = 50*ones(N); rho1 = rho0;
rho0(2:7,2:7) = 255; rho1(10:15,5:10) = 255;

rho0=rho0/255;
rho1=rho1/255;

figure(1), imshow(rho0);
figure(2), imshow(rho1);

summ = sum(sum(rho0));
rho0=rho0/summ;
rho1=rho1/summ;
%% Initial
[rho, mx, my]=initial(rho0, rho1, x_max, T);

u = transfer(rho,mx, my);
tic
[C, c]=div(rho0, rho1, x_max, N ,T);
A=sparse(C(1:size(C,1)-1, 1:size(C,2)));
b=c(1:size(C,1)-1);
%B=(A*A')^(-1);
invAAtb = (A*A')\b;
invAAtA = (A*A')\A;
toc
pause(5)
%% Algorthim
tic;
gold = grad(u,x_max, N, T, beta);
uold = u;
Obj=zeros(1e5,1);

for k=1:1e5
    uu=u;
    % aa=agrad(u, N, T,dx,beta);
    g = grad(u,x_max, N, T,beta);
    if k >= 2
        h = .1*sum((u-uold).^2)/abs((u-uold)'*(gold-g));        
    end 
    u=u-g*h;
    u=proj(u, A, invAAtA, invAAtb);   
    Obj(k)=energy(u, N, T, dx, beta);
    %[ENG min(u(1:N^2*(T-1)))]
    if k == 1
        relerr = inf;
    else 
        relerr = abs(Obj(k)-Obj(k-1))/abs(Obj(k-1))              
    end 
    if relerr < tol
        break;
    end  
    uold = uu;
    gold = g;
end
toc;
[rho, mx, my]=transfer1(u, N, T);
close all
figure
Obj = Obj(Obj>0);
semilogy(Obj)

figure
for k=1:T
    imshow(rho(:,:, k)*summ);
    set(gca,'position',[0 0 1 1],'units','normalized') 
    clear gca
    M(k)=getframe;
end

 