%% Projection Gradient method Main function
clc; clear; close all
T=20; x_max=2; N=15; 
dx=x_max/(N-1); dt=1/(T-1);

params.maxIter = 500; 
params.tol = 1e-5; 
params.stepsz = .3;
params.beta = 1e-6; x_max = 2; 

rho0 = ones(N); rho1 = rho0;
rho0(2:7,2:7) = 255; rho1(10:15,5:10) = 255;

rho0=rho0/255;
rho1=rho1/255;

figure(1), imshow(rho0);
figure(2), imshow(rho1);

sum = sum(sum(rho0));
rho0=rho0/sum;
rho1=rho1/sum;


%% Proximal Newton
tic;
[rho, mx, my, Obj] = proxNewton(rho0,rho1,x_max,N,T,params);
toc;
%%
close all
figure(3)
Obj = Obj(Obj>0);
semilogy(Obj)

figure(4)
for k=1:T
    imshow(rho(:,:, k)*sum);
    set(gca,'position',[0 0 1 1],'units','normalized') 
    clear gca
    M(k)=getframe;
end
%%
% save('square2.mat','Obj','rho');
% movie2avi(M,'square2.avi');


