clear, close all
I0 = double(rgb2gray(imread('tiger.jpg')));
I1 = double(rgb2gray(imread('lion.jpg')));
N = 40;
I0 = imresize(I0,[N,N])/255;
I1 = imresize(I1,[N,N])/255;
figure(1), imshow(I0)
figure(2), imshow(I1)
rho0 = prep(I0); rho1 = prep(I1);
mass0 = sum(sum(rho0)); mass1 = sum(sum(rho1));
rho0 = rho0/mass0; rho1 = rho1/mass1;

%%
T = 40; 
params.maxIter = 300; 
params.tol = 1e-5; 
params.stepsz = .5;
params.beta = 1e-6; x_max = 2; 
tic;
[rho, mx, my, Obj] = proxNewton(rho0,rho1,x_max,N,T,params);
toc;
%% plot

figure(3)
Obj = Obj(Obj>0);
semilogy(Obj)
figure(4)
for k=0:T
    if k == 0
        imshow(I0)
        set(gca,'position',[0 0 1 1],'units','normalized')
        clear gca
    else
        scalar = ((T-k)*mass0 + k*mass1)/T;
        imshow(rho(:,:, k)*scalar);
        set(gca,'position',[0 0 1 1],'units','normalized')
        clear gca
    end
    M(k+1)=getframe;
end
%%
save('cat.mat','Obj','rho','mx','my')
movie2avi(M,'cat.avi');