clc, clear, close all
load mnist_img.mat;
I0 = ims{3}; I1 = ims{8};

figure(1), imshow(I0)
figure(2), imshow(I1)

rho0 = prep(I0); rho1 = prep(I1);
mass0 = sum(sum(rho0)); mass1 = sum(sum(rho1));
rho0 = rho0/mass0; rho1 = rho1/mass1;

%%
N = size(I0,1); T = 30; 
params.maxIter = 200; 
params.tol = 1e-5; 
params.stepsz = .3;
params.beta = 1e-6; x_max = 2; 
tic;
[rho, mx, my, Obj] = proxNewton(rho0,rho1,x_max,N,T,params);
toc;

%% plot
% load mnist2.mat; T = 30;
%close all
figure(3)
Obj = Obj(Obj>0);
semilogy(Obj)
%clear gca
figure(4)
for k=0:T
    if k == 0
        imshow(I0)
        set(gca,'position',[0 0 1 1],'units','normalized')
        clear gca
    else
        scalar = ((T-k)*mass0 + k*mass1)/T;
        imshow(rho(:,:, k)*scalar);
        set(gca,'position',[0 0 1 1],'units','normalized')
        clear gca
    end
    M(k+1)=getframe;
end
%%
save('mnist1.mat','Obj','rho')
movie2avi(M,'mnist1.avi');