function u=transfer(rho, mx, my)
% 2 dimensional problem
% u=[p m]
% P: k=2...T, i=1...N, j=1...N ; Total (T-1)*N^2
% mx: k=2...T, i=1...N-1; j=1...N Total (T-1)*(N-1)*N
% my: k=2...T, i=1...N; j=1...N-1 Total (T-1)*(N-1)*N
% f (i, k) for P; g (i, k) for m;
N=size(rho,1);
T=size(rho,3);
u=zeros(N^2*(T-1)+ 2*(N-1)*N*(T-1),1);

f=@(i,j,k) i+(j-1)*N+(k-2)*N^2; % p total N^2*(T-1)
gx=@(i,j,k) N^2*(T-1)+i+(j-1)*(N-1)+(k-2)*(N-1)*N; % mx total (N-1)*N*(T-1)
gy=@(i,j,k) N^2*(T-1)+(N-1)*N*(T-1)+i+(j-1)*N+(k-2)*(N-1)*N; % my total (N-1)*N*(T-1)


for i=1:N
    for j=1:N
        for k=2:T
            u(f(i,j,k))=rho(i,j,k);
        end
    end
end

for i=1:N-1
    for j=1:N
        for k=2:T
            u(gx(i,j,k))=mx(i,j,k);
        end
    end
end

for i=1:N
    for j=1:N-1
        for k=2:T
            u(gy(i,j,k))=my(i,j,k);
        end
    end
end